/**
 * NOTE: This class is auto generated by the swagger code generator program (2.4.21).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package mx.sidlors.dvd.rental.api;

import  mx.sidlors.dvd.rental.model.Rental;
import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2021-07-21T02:33:33.560Z")

@Validated
@Api(value = "rental", description = "the rental API")
@RequestMapping(value = "")
public interface RentalApi {

    @ApiOperation(value = "", nickname = "rentalDelete", notes = "", tags={ "rental", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/rental",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.DELETE)
    ResponseEntity<Void> rentalDelete(@ApiParam(value = "") @Valid @RequestParam(value = "rental_id", required = false) String rentalId,@ApiParam(value = "") @Valid @RequestParam(value = "rental_date", required = false) String rentalDate,@ApiParam(value = "") @Valid @RequestParam(value = "inventory_id", required = false) String inventoryId,@ApiParam(value = "") @Valid @RequestParam(value = "customer_id", required = false) String customerId,@ApiParam(value = "") @Valid @RequestParam(value = "return_date", required = false) String returnDate,@ApiParam(value = "") @Valid @RequestParam(value = "staff_id", required = false) String staffId,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "rentalGet", notes = "", response = Rental.class, responseContainer = "List", tags={ "rental", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = Rental.class, responseContainer = "List"),
        @ApiResponse(code = 206, message = "Partial Content") })
    @RequestMapping(value = "/rental",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.GET)
    ResponseEntity<List<Rental>> rentalGet(@ApiParam(value = "") @Valid @RequestParam(value = "rental_id", required = false) String rentalId,@ApiParam(value = "") @Valid @RequestParam(value = "rental_date", required = false) String rentalDate,@ApiParam(value = "") @Valid @RequestParam(value = "inventory_id", required = false) String inventoryId,@ApiParam(value = "") @Valid @RequestParam(value = "customer_id", required = false) String customerId,@ApiParam(value = "") @Valid @RequestParam(value = "return_date", required = false) String returnDate,@ApiParam(value = "") @Valid @RequestParam(value = "staff_id", required = false) String staffId,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Ordering") @Valid @RequestParam(value = "order", required = false) String order,@ApiParam(value = "Limiting and Pagination" ) @RequestHeader(value="Range", required=false) String range,@ApiParam(value = "Limiting and Pagination" , defaultValue="items") @RequestHeader(value="Range-Unit", required=false) String rangeUnit,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "offset", required = false) String offset,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "limit", required = false) String limit,@ApiParam(value = "Preference" , allowableValues="count=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "rentalPatch", notes = "", tags={ "rental", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/rental",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.PATCH)
    ResponseEntity<Void> rentalPatch(@ApiParam(value = "") @Valid @RequestParam(value = "rental_id", required = false) String rentalId,@ApiParam(value = "") @Valid @RequestParam(value = "rental_date", required = false) String rentalDate,@ApiParam(value = "") @Valid @RequestParam(value = "inventory_id", required = false) String inventoryId,@ApiParam(value = "") @Valid @RequestParam(value = "customer_id", required = false) String customerId,@ApiParam(value = "") @Valid @RequestParam(value = "return_date", required = false) String returnDate,@ApiParam(value = "") @Valid @RequestParam(value = "staff_id", required = false) String staffId,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "rental"  )  @Valid @RequestBody Rental rental,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "rentalPost", notes = "", tags={ "rental", })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "Created") })
    @RequestMapping(value = "/rental",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.POST)
    ResponseEntity<Void> rentalPost(@ApiParam(value = "rental"  )  @Valid @RequestBody Rental rental,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);

}
